package com.jiuqi.mde;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.mde.MDEDimValueSet;
import com.jiuqi.mde.MDEException;
import java.util.ArrayList;

public class MDEDimValueSetCollection {
  protected ArrayList dimValuesList;
  
  public MDEDimValueSetCollection() {
    this.dimValuesList = new ArrayList();
  }
  
  public MDEDimValueSetCollection(int capacity) {
    this.dimValuesList = new ArrayList(capacity);
  }
  
  public final int size() {
    return this.dimValuesList.size();
  }
  
  public final MDEDimValueSet get(int index) {
    return this.dimValuesList.get(index);
  }
  
  public final void clear() {
    this.dimValuesList.clear();
  }
  
  public void add(MDEDimValueSet dimValues) {
    if (indexOf(dimValues) < 0)
      this.dimValuesList.add(dimValues.clone()); 
  }
  
  public final boolean contains(MDEDimValueSet dimValues) {
    return (indexOf(dimValues) >= 0);
  }
  
  public final int indexOf(MDEDimValueSet dimValues) {
    for (int i = 0; i < this.dimValuesList.size(); i++) {
      MDEDimValueSet dvs = this.dimValuesList.get(i);
      if (dimValues.equals(dvs))
        return i; 
    } 
    return -1;
  }
  
  public final MDEDimValueSet remove(int index) {
    return this.dimValuesList.remove(index);
  }
  
  public final void include(MDEDimValueSet dimValues) {
    for (int i = 0; i < this.dimValuesList.size(); i++) {
      MDEDimValueSet dvs = this.dimValuesList.get(i);
      if (dvs.equals(dimValues))
        return; 
      if (dvs.matches(dimValues)) {
        this.dimValuesList.set(i, dimValues.clone());
        return;
      } 
    } 
    this.dimValuesList.add(dimValues.clone());
  }
  
  public final void exclude(MDEDimValueSet dimValues) throws MDEException {
    int index = indexOf(dimValues);
    if (index >= 0) {
      this.dimValuesList.remove(index);
    } else {
      int i;
      for (i = 0; i < this.dimValuesList.size(); i++) {
        MDEDimValueSet dvs = this.dimValuesList.get(i);
        if (dimValues.matches(dvs))
          throw new MDEException("不能部分删除维度值集"); 
      } 
      for (i = this.dimValuesList.size() - 1; i >= 0; i--) {
        MDEDimValueSet dvs = this.dimValuesList.get(i);
        if (dvs.matches(dimValues)) {
          this.dimValuesList.remove(i);
          break;
        } 
      } 
    } 
  }
  
  public final boolean isIncluded(MDEDimValueSet dimValues) {
    for (int i = 0; i < this.dimValuesList.size(); i++) {
      MDEDimValueSet dvs = this.dimValuesList.get(i);
      if (dimValues.matches(dvs))
        return true; 
    } 
    return false;
  }
  
  public static void main(String[] args) throws Exception {
    Object[] ad1 = new Object[3];
    ad1[1] = new String("abc");
    System.out.println(ad1.hashCode());
    ad1[2] = new Integer(3);
    System.out.println(ad1.hashCode());
    Object[] ad2 = new Object[3];
    ad2[1] = new String("abc");
    System.out.println(ad2.hashCode());
    ad2[2] = new Integer(3);
    System.out.println(ad2.hashCode());
    System.out.println(ad1.equals(ad2));
  }
}
